/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2006 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * "Support Open Source software. What about a donation today?"
 * 
 * File Name: fckplugin.js
 * 	Plugin to insert "ImageAdjustor" in the editor.
 * 
 * File Authors:
 * 		Akira Taniguchi (akira@behappy.2-d.jp)
 */

//==============================================================================
// Lightbox Add

// Register the related command.
var oLightboxAddCommand = new FCKDialogCommand( 'LightboxAdd', FCKLang.LightboxAddDlgTitle, FCKPlugins.Items['Lightbox_Plus'].Path + 'fck_lightbox.html', 280, 320 );

oLightboxAddCommand.GetState = function()
{
	var oSel = FCKSelection.GetSelectedElement();
	
	if ( oSel == undefined ) return FCK_TRISTATE_DISABLED ;
	if ( oSel.tagName != 'IMG' ) return FCK_TRISTATE_DISABLED ;
    if ( oSel.getAttribute( '_fckfakelement' ) ) return FCK_TRISTATE_DISABLED ;
	if ( oSel.src.length == 0 ) return FCK_TRISTATE_DISABLED ;
	if ( oSel.parentNode.tagName == 'A' )
	{
		if ( ! oSel.parentNode.rel ) return FCK_TRISTATE_DISABLED ;
		if ( ! oSel.parentNode.rel.match( /^lightbox(\[[^\]]*\])?$/ ) ) return FCK_TRISTATE_DISABLED ;
	}
	
	return FCK_TRISTATE_OFF ;
}

FCKCommands.RegisterCommand( 'LightboxAdd', oLightboxAddCommand ) ;

// Create the "LightboxAdd" toolbar button.
var oLightboxAddItem = new FCKToolbarButton( 'LightboxAdd', FCKLang.LightboxAddBtn, null, null, false, true ) ;
oLightboxAddItem.IconPath = FCKPlugins.Items['Lightbox_Plus'].Path + 'icon_add.gif' ;

FCKToolbarItems.RegisterItem( 'LightboxAdd', oLightboxAddItem ) ;

//==============================================================================
// Lightbox Del

var FCKLightboxDelCommand = function()
{
	this.Name = 'LightboxDel' ;
}

FCKLightboxDelCommand.prototype.Execute = function()
{
	if ( FCKBrowserInfo.IsGecko )
	{
		var oLink = FCKSelection.GetParentElement() ;
		if ( oLink ) 
			FCK.Selection.SelectNode( oLink ) ;
	}
	
	FCK.ExecuteNamedCommand( 'Unlink' ) ;
	
	if ( FCKBrowserInfo.IsGecko )
		FCK.Selection.Collapse( true ) ;
}

FCKLightboxDelCommand.prototype.GetState = function()
{
	var oSel = FCKSelection.GetSelectedElement();
	
	if ( oSel == undefined ) return FCK_TRISTATE_DISABLED ;
	if ( oSel.tagName != 'IMG' ) return FCK_TRISTATE_DISABLED ;
    if ( oSel.getAttribute( '_fckfakelement' ) ) return FCK_TRISTATE_DISABLED ;
	if ( oSel.src.length == 0 ) return FCK_TRISTATE_DISABLED ;
	if ( oSel.parentNode.tagName != 'A' ) return FCK_TRISTATE_DISABLED ;
	if ( ! oSel.parentNode.rel ) return FCK_TRISTATE_DISABLED ;
	if ( ! oSel.parentNode.rel.match( /^lightbox(\[[^\]]*\])?$/ ) ) return FCK_TRISTATE_DISABLED ;
	
	return FCK_TRISTATE_OFF ;
}

var oLightboxDelCommand = new FCKLightboxDelCommand() ;

FCKCommands.RegisterCommand( 'LightboxDel', oLightboxDelCommand ) ;

// Create the "LightboxDel" toolbar button.
var oLightboxDelItem = new FCKToolbarButton( 'LightboxDel', FCKLang.LightboxDelBtn, null, null, false, true ) ;
oLightboxDelItem.IconPath = FCKPlugins.Items['Lightbox_Plus'].Path + 'icon_del.gif' ;

FCKToolbarItems.RegisterItem( 'LightboxDel', oLightboxDelItem ) ;

//==============================================================================
// Lightbox Contextmenu

// Register "LightboxDel" to contextmenu.
FCK.ContextMenu.RegisterListener( {
    AddItems : function( menu, tag, tagName )
    {
        // under what circumstances do we display this option
        
        var enableAdd = false ;
        var enableDel = false ;
        
        if ( tagName != 'IMG' ) return ;
        if ( tag.getAttribute( '_fckfakelement' ) ) return ;
        if ( tag.src.length == 0 ) return ;
        if ( tag.src == '' ) return ;
        
       	if ( tag.parentNode.tagName == 'A' )
       	{
			if ( tag.parentNode.rel )
				if ( tag.parentNode.rel.match( /^lightbox(\[[^\]]*\])?$/ ) )
				{
			        enableAdd = true ;
			        enableDel = true ;
			    }
       	}
       	else
       	{
	        enableAdd = true ;
	    }
	    
        // the command needs the registered command name, the title for the context menu, and the icon path
        if ( enableAdd || enableDel )
	        menu.AddSeparator() ;
	    
        if ( enableAdd )
	        menu.AddItem( 'LightboxAdd', FCKLang.LightboxAddBtn, oLightboxAddItem.IconPath ) ;
        
        if ( enableDel )
    	    menu.AddItem( 'LightboxDel', FCKLang.LightboxDelBtn, oLightboxDelItem.IconPath ) ;
    }
} );

//==============================================================================
// Preview

var FCKLightboxPreviewCommand = function()
{
	this.Name = 'Preview' ;
}

FCKLightboxPreviewCommand.prototype.Execute = function()
{
	var iWidth	= FCKConfig.ScreenWidth * 0.8 ;
	var iHeight	= FCKConfig.ScreenHeight * 0.7 ;
	var iLeft	= ( FCKConfig.ScreenWidth - iWidth ) / 2 ;
	var oWindow = window.open( '', null, 'toolbar=yes,location=no,status=yes,menubar=yes,scrollbars=yes,resizable=yes,width=' + iWidth + ',height=' + iHeight + ',left=' + iLeft ) ;
	
	var LightboxPath = FCKPlugins.Items['Lightbox_Plus'].Path + 'lightbox_plus/' ;
	
	var sHTML = '';
	
	if ( FCKConfig.FullPage )
	{
		if ( FCK.TempBaseTag.length > 0 )
			sHTML += FCK.TempBaseTag + '\n' ;
		
		sHTML += FCK.GetXHTML() + '\n' ;
	}
	else
	{
		if ( FCKConfig.DocType != '' )
			sHTML += FCKConfig.DocType + '\n';
		
		sHTML += '<html dir="' + FCKConfig.ContentLangDirection + '">\n' ;
		sHTML += '<head>\n' ;
		
		if ( FCK.TempBaseTag != '' )
			sHTML += FCK.TempBaseTag + '\n' ;
		
		sHTML += '<title>' + FCKLang.Preview + '</title>\n' ;
		sHTML += FCK._GetEditorAreaStyleTags() + '\n' ;
		sHTML += '</head>\n' ;
		sHTML += '<body>\n' ;
		sHTML += FCK.GetXHTML() + '\n' ;
		sHTML += '</body>\n' ;
		sHTML += '</html>\n' ;
	}
	
	sHTML += '<link type="text/css" rel="stylesheet" href="' + LightboxPath + 'css/lightbox.css" media="screen" charset="utf-8" />\n' ;
	sHTML += '<script type="text/javascript" src="' + LightboxPath + 'js/spica.js" charset="utf-8"><\/script>\n' ;
	sHTML += '<script type="text/javascript" src="' + LightboxPath + 'js/lightbox_plus.js" charset="utf-8"><\/script>\n' ;
	
	oWindow.document.write( sHTML );
	oWindow.document.close();
}

FCKLightboxPreviewCommand.prototype.GetState = function()
{
	return FCK_TRISTATE_OFF ;
}

var oLightboxPreviewCommand = new FCKLightboxPreviewCommand() ;

FCKCommands.RegisterCommand( 'Preview', oLightboxPreviewCommand ) ;
